# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
require 'easy_type/flexible_fact'
require 'puppet_x/enterprisemodules/weblogic/facts'

EasyType::FlexibleFact.define(:wls_install_homes) do
  extend Puppet_X::EnterpriseModules::WebLogic::Facts

  components get_homes(get_orainst_loc)

  part(:product_version) do |component|
    get_version(component)
  end

  part(:opatch_version) do |component|
    get_opatch_version(component)
  end

  part(:installed_features) do |component|
    get_installed_features(component)
  end

  part(:running_domains) do |component|
    get_running_domains(component)
  end

  part(:installed_patches) do |component|
    get_installed_patches(component)
  end
end
