# frozen_string_literal: true

#
# This function checks if WebLogic is installed.
#
#
# See the file "LICENSE" for the full license governing this code.
#
Puppet::Functions.create_function(:'wls_install::weblogic_exists') do
  dispatch :weblogic_exists do
    param 'String', :name
    return_type 'Boolean'
  end

  def weblogic_exists(name)
    scope = closure_scope
    fact = scope['wls_install_homes']
    fail 'fact wls_install_homes should be a Hash' if fact.class != Hash

    if fact.empty?
      call_function('wls_install::log', 'weblogic_exists wls_install_homes empty, return false')
      return false
    elsif fact['installed_features'].key?(name)
      call_function('wls_install::log', "weblogic_exists middleware home '#{name}' exists, return true")
      return true
    end
    call_function('wls_install::log', "weblogic_exists middleware home '#{name}' not found, return false")
    false
  end
end
